<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
//

/**
 * products_image_manager.php - modified by Tim Kroeger for integration
 * with Image Handler also by Tim Kroeger <tim@breakmyzencart.com>
 *   Release Version: 1.0-beta2
 * 
 * Based on Image Manager by Samuel Lown <me(at)samlown.com> 
 * Release Version: 0.4 - 2005-02-10 - Beta 
 * 
 * Originally based on products_price_manager.php, part of the standard
 * Zen Cart distribution.
 */  

  require('includes/application_top.php');
  require(DIR_WS_CLASSES . 'currencies.php');
  $currencies = new currencies();

  $products_filter = (isset($_GET['products_filter']) ? $_GET['products_filter'] : $products_filter);

  $action = (isset($_GET['action']) ? $_GET['action'] : '');

  $current_category_id = (isset($_GET['current_category_id']) ? $_GET['current_category_id'] : $current_category_id);

  // Max image sizes (for large Image)
  $largeImageWidth = (LARGE_IMAGE_MAX_WIDTH != null) ? LARGE_IMAGE_MAX_WIDTH : '';
  $largeImageHeight = (LARGE_IMAGE_MAX_HEIGHT != null) ? LARGE_IMAGE_MAX_HEIGHT : '';
  
  /*
   * Override permissions option
   *   - allow the module to set the permissions of the target directory and files
   *   - the parent directory permissions are read, and matched by the target file.
   */
  $override_permissions = 0;

  if ($action == 'new_cat') {
    $current_category_id = (isset($_GET['current_category_id']) ? $_GET['current_category_id'] : $current_category_id);
    $new_product_query = $db->Execute("select ptc.* from " . TABLE_PRODUCTS_TO_CATEGORIES . " ptc  left join " . TABLE_PRODUCTS_DESCRIPTION . " pd on ptc.products_id = pd.products_id and pd.language_id = '" . (int)$_SESSION['languages_id'] . "' where ptc.categories_id='" . $current_category_id . "' order by pd.products_name");
    $products_filter = $new_product_query->fields['products_id'];
    zen_redirect(zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $products_filter . '&current_category_id=' . $current_category_id));
  }

// set categories and products if not set
  if ($products_filter == '' and $current_category_id != '') {
    $new_product_query = $db->Execute("select ptc.* from " . TABLE_PRODUCTS_TO_CATEGORIES . " ptc  left join " . TABLE_PRODUCTS_DESCRIPTION . " pd on ptc.products_id = pd.products_id and pd.language_id = '" . (int)$_SESSION['languages_id'] . "' where ptc.categories_id='" . $current_category_id . "' order by pd.products_name");
    $products_filter = $new_product_query->fields['products_id'];
    if ($products_filter != '') {
      zen_redirect(zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $products_filter . '&current_category_id=' . $current_category_id));
    }
  } else {
    if ($products_filter == '' and $current_categories_id == '') {
      $reset_categories_id = zen_get_category_tree('', '', '0', '', '', true);
      $current_category_id = $reset_categories_id[0]['id'];
      $new_product_query = $db->Execute("select ptc.* from " . TABLE_PRODUCTS_TO_CATEGORIES . " ptc  left join " . TABLE_PRODUCTS_DESCRIPTION . " pd on ptc.products_id = pd.products_id and pd.language_id = '" . (int)$_SESSION['languages_id'] . "' where ptc.categories_id='" . $current_category_id . "' order by pd.products_name");
      $products_filter = $new_product_query->fields['products_id'];
      $_GET['products_filter'] = $products_filter;
    }
  }

  require(DIR_WS_MODULES . FILENAME_PREV_NEXT);

// END OF PRODUCT SELECTION CODE

  
  if (zen_not_null($action)) {
    switch ($action) {
    	case 'query_single_images':
    		$max_products = (isset($_GET['query_size']) && zen_not_null($_GET['query_size'])) ? intval($_GET['query_size']) : 0;
    		$products = $db->Execute("select products_id, products_image from " . TABLE_PRODUCTS . " where products_image != '' order by products_image asc");
    		$previous_image = '';
    		$index = 0;
    		$resizeproducts = array();
    		$resizeimages = array();
    		while (($index < $max_products) &&  (!$products->EOF)) {
    			$image = $products->fields['products_image'];
    			if ($image != $previous_image) {
    				$previous_image = $image;
					list($newwidth, $newheight, $resize_image) = zen_calculate_image_size(DIR_FS_CATALOG_IMAGES . $image, SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT);
					if ($resize_image) {
						$resizeimages[$index] = $image;
						$resizeproducts[$index] = $products->fields['products_id'];
						$index++;  
	    			}
    			}
				$products->MoveNext();
    		}
    	break;
		case 'resize_single_images':
		    $product_set = (isset($_GET['products']) && zen_not_null($_GET['products'])) ? $_GET['products'] : '';
		    if ($product_set != '') {
	    		$images = $db->Execute("select products_image from " . TABLE_PRODUCTS . " where products_id in (" . $product_set . ") order by products_image");
		    }
		break;
      case 'set_products_filter':
        $_GET['products_filter'] = $_POST['products_filter'];

        zen_redirect(zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $_GET['products_filter']));
        break;
      
      ////////////////////////////////////// SAVE 
      case 'save':
      	      	
      	$check = 0;
      	$data = array();
      	
      	// Check the data
      	if ($_GET['newImg'] == 1) {
	      	// New Image Name and Base Dir
	      	if ( $_POST['imgAutoBase'] == 'Y' ) {
	      		// Extract the name from the default file
      			if ($_FILES['default_image']['name'] != '') {
      				preg_match("/(.+)\.[^\.]+$/", $_FILES['default_image']['name'], $matches);
      				$data['imgBase'] = $matches[1];
      			} else {
      				$messageStack->add(TEXT_MSG_AUTO_BASE_ERROR, 'error');
      				$check = 1;
      			}
	      	
	      	} else if ( ($_POST['imgBase'] != '') ) {
      			$data['imgBase'] = $_POST['imgBase'];
      		} else {
       			$messageStack->add( TEXT_MSG_INVALID_BASE_ERROR, 'error' );
     			$check = 1;
      		}
      		
      		// catch nasty characters
      		if (ereg("\+", $data['imgBase'])) {
      			$data['imgBase'] = ereg_replace("\+", "-", $data['imgBase']);
      			$messageStack->add( TEXT_MSG_AUTO_REPLACE .$data['imgBase'], 'warning' );
      		}
      		
      		if ( $_POST['imgNewBaseDir'] != '') {
      			$data['imgBaseDir'] = $_POST['imgNewBaseDir'];
      		} else {
      			$data['imgBaseDir'] = $_POST['imgBaseDir'];
      		}
      		
      		$data['imgSuffix'] = "";
      		
      	} else if ($_GET['imgEdit'] == 1) {
      		// The image is being edited
      		$data['imgBaseDir'] = $_GET['imgBaseDir'];
      		$data['imgBase'] = $_GET['imgBase'];
      		$data['imgExtension'] = $_GET['imgExtension'];
      		$data['imgSuffix'] = $_GET['imgSuffix'];

      	} else {
      		// An additional image is being added
      		$data['imgBaseDir'] = $_GET['imgBaseDir'];
      		$data['imgBase'] = $_GET['imgBase'];
      		$data['imgExtension'] = $_GET['imgExtension'];
      	      	
    		// Image Suffix (if set)
      		if ($_POST['imgAutoSuffix'] == 'Y') {
      			// get directory list
      			$array = array();
      			find_additional_images($array, DIR_FS_CATALOG . DIR_WS_IMAGES . $data['imgBaseDir'], 
      				$data['imgExtension'], $data['imgBase'] );
      			
      			$c = sizeof( $array );
      			if ($c > 1) {
      				sort($array);
      			}
      			
      			// calculate the next suffix
      			// (This is lame, unscalable, and inefficient, but effective)
      			$suffix = 1;
      			$m = 0;
      			while ($m != 1) {
      				
      				if ($suffix < 10) {
	      				$suffixStr = "0".$suffix;
	      			} else { 
	      				$suffixStr = $suffix;
	      			}
	      			
	      			$string = $data['imgBase'] . '_'. $suffixStr;
	      			$n = 0;
	      			for ($i=0; $i < $c; $i++) {
	      				if ($array[$i] == $string) {
	      					$n = 1;
	      				} 
	      			}
	      			if ($n == 1) {
	      				$suffix++;
	      			} else {
	      				$data['imgSuffix'] = "_".$suffixStr;
	      				$m = 1; 
	      			}
	      		}
      			 
      		} else {
      			if ($_POST['imgSuffix'] != '') {
	      			$data['imgSuffix'] = '_'.$_POST['imgSuffix'];
	      		} else {
	      			$messageStack->add( TEXT_MSG_INVALID_SUFFIX, 'error' );
	      			$check = 1;
	      		}
      		}
      	

      	
      	} // if newImg
      	
      	
      	
		if (IMAGE_MANAGER_HANDLER && 
			(
				((IMAGE_MANAGER_HANDLER == 'ImageMagick')
						&& (((file_exists(DIR_FS_IMAGE_MAGICK . 'convert')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'composite')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'montage'))))
							|| ((file_exists(DIR_FS_IMAGE_MAGICK . 'convert.exe')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'composite.exe')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'montage.exe'))))
				|| (IMAGE_MANAGER_HANDLER == 'GD'))
			) { // test if some ImageHandler specified
      	
      	// Check for Default image file
      	if ($_FILES['default_image']['name'] != '') {
      		// get file extension 
      		$extension = substr( $_FILES['default_image']['name'], 
      			strrpos($_FILES['default_image']['name'], '.'));

      		if (!($data['imgExtension'])) {
      			$data['imgExtension'] = $extension;
      		}
      			
        } else if ($_GET['imgEdit'] == 1) {
			// Editing the images, perhaps we don't want to update the default
			// check that AutoSize has not been defined
			if (($_POST['imgAutoMedium'] == 'Y') || ($_POST['imgAutoLarge'] == 'Y')) {
				$messageStack->add( TEXT_MSG_DEFAULT_REQUIRED_FOR_RESIZE, 'error' );
				$check = 1;			
			}		
			
      	} else {
      		$messageStack->add( TEXT_MSG_NO_DEFAULT, 'error' );
      		$check = 1;
      	}

      	// determine the filenames 
      	if ($check != 1) {
      		// add slash to base dir
      		if (($data['imgBaseDir'] != '') && (!ereg("\/$", $data['imgBaseDir']))) {
      			$data['imgBaseDir'] .= '/';	
      		}
      		$image_extension = $data['imgExtension'];
			$small_file_extension = ((SMALL_IMAGE_FILETYPE == 'no_change') ? $image_extension : '.' . SMALL_IMAGE_FILETYPE);
			$medium_file_extension = ((MEDIUM_IMAGE_FILETYPE == 'no_change') ? $image_extension : '.' . MEDIUM_IMAGE_FILETYPE);
			$large_file_extension = ((LARGE_IMAGE_FILETYPE == 'no_change') ? $image_extension : '.' . LARGE_IMAGE_FILETYPE);
			

      		$data['fileName'] = $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . $small_file_extension;
      			
      		// Determine new default file name
      		$data['defaultFileName'] = $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . $small_file_extension;
      		$data['largeFileName'] = 'large/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_LARGE
      			. $large_file_extension;
      		$data['mediumFileName'] ='medium/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_MEDIUM
      			. $medium_file_extension;
      		
      		// Check if the file already exists
      		if ( ($_GET['imgEdit'] != 1) && (file_exists(DIR_FS_CATALOG . DIR_WS_IMAGES . $data['defaultFileName'])) ) {
      			$messageStack->add( TEXT_MSG_FILE_EXISTS, 'error' );
      			$check = 1;
      		}
      		
      		// Repeat for the Medium and Large images
      	}

      	 
      
      	// Update the database
      	if (($check != 1) && ($_GET['newImg'] == 1)) {
      		// update the database
      		$sql = "update ". TABLE_PRODUCTS . " set products_image='"
      			.$data['fileName']."' where products_id='".$products_filter."'";
      		if ( ! $db->Execute($sql) ) {
      			$messageStack->add(TEXT_MSG_INVALID_SQL, "error");
      			$check = 1;
      		}

      	}

		if ($check != 1) {
			// check for destination directory
      		if ( !is_dir(DIR_FS_CATALOG.DIR_WS_IMAGES.$data['imgBaseDir']) ) {
      			// doesn't exist, create it!
      			if ( !mkdir( DIR_FS_CATALOG.DIR_WS_IMAGES.$data['imgBaseDir'] ) ) {
      				$messageStack->add( TEXT_MSG_NOCREATE_IMAGE_DIR, 'error' );
      				$check = 1;	
      			}
      		}
      		if ( !is_dir(DIR_FS_CATALOG.DIR_WS_IMAGES.'medium/'.$data['imgBaseDir']) ) {
      			// doesn't exist, create it!
      			if ( !mkdir( DIR_FS_CATALOG.DIR_WS_IMAGES.'medium/'.$data['imgBaseDir'] ) ) {
      				$messageStack->add( TEXT_MSG_NOCREATE_MEDIUM_IMAGE_DIR, 'error' );
      				$check = 1;	
      			}
      		}
      		if ( !is_dir(DIR_FS_CATALOG.DIR_WS_IMAGES.'large/'.$data['imgBaseDir']) ) {
      			// doesn't exist, create it!
      			if ( !mkdir( DIR_FS_CATALOG.DIR_WS_IMAGES.'large/'.$data['imgBaseDir'] ) ) {
      				$messageStack->add( TEXT_MSG_NOCREATE_LARGE_IMAGE_DIR, 'error' );
      				$check = 1;	
      			}
      		}		
		}
		
		// check and set the directory permissions
		if (($check !=1) && ($override_permissions == 1)) {
			// read the permissions from the images directory
			$perms = fileperms( DIR_FS_CATALOG.DIR_WS_IMAGES );
			// set the directories to the same values
			if ( !chmod(DIR_FS_CATALOG.DIR_WS_IMAGES.$data['imgBaseDir'], $perms) ) {
      			// doesn't exist, create it!
   				$messageStack->add( TEXT_MSG_NOPERMS_IMAGE_DIR, 'warning' );
      		}
      		if ( !chmod(DIR_FS_CATALOG.DIR_WS_IMAGES.'medium/'.$data['imgBaseDir'], $perms) ) {
      			$messageStack->add( TEXT_MSG_NOPERMS_MEDIUM_IMAGE_DIR, 'warning' );
      		}
      		if ( !chmod(DIR_FS_CATALOG.DIR_WS_IMAGES.'large/'.$data['imgBaseDir'], $perms) ) {
   				$messageStack->add( TEXT_MSG_NOPERMS_LARGE_IMAGE_DIR, 'warning' );
      		}	
		
			// remove just sticky bits for files, execution has to be there for a few people
			// with strange server configurations. (hopefully this is ok for most people!)
			$perms &= 00777; // ow, been a while since I did binary ops! 
		}
      	
      	if ($check != 1) {
	      	$source_name = $_FILES['default_image']['tmp_name'];
			// generate directory for original image (not needed anymore after generation)
			mkdirr(DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir']);
		
			// move original image away
			$destination_name = DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir'] . $data['imgBase'] . $data['imgSuffix'] . $data['imgExtension'];
			bmz_set_visible($destination_name);
			if (is_file($destination_name)) {
				@unlink($destination_name);
			}
      	}

      	if ($check != 1) {
      		if ( !move_uploaded_file($source_name, $destination_name) ) {
      			$messageStack->add( TEXT_MSG_NOUPLOAD_DEFAULT, "error" );
      			$check = 1;
      		} else {
				$source_name = $destination_name;
      		}
      	}
      	$default_source_name = $source_name; 

      	
      	if ($check != 1) {
	      	
			//set sizes for future images
			list($small_width, $small_height) = zen_calculate_image_size($default_source_name, SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT);
			$small_size  = $small_width . "x" . $small_height;
	
			list($medium_width, $medium_height) = zen_calculate_image_size($default_source_name, MEDIUM_IMAGE_WIDTH, MEDIUM_IMAGE_HEIGHT);
			$medium_size  = $medium_width . "x" . $medium_height;

			list($large_width, $large_height) = zen_calculate_image_size($default_source_name, $largeImageWidth, $largeImageHeight);
			$large_size = $large_width . 'x' . $large_height;

			$image_large = DIR_FS_CATALOG_IMAGES . $data['largeFileName'];
			$image_medium = DIR_FS_CATALOG_IMAGES . $data['mediumFileName'];
			$image_small = DIR_FS_CATALOG_IMAGES . $data['defaultFileName'];
      	}
		
		// process large file
      	if ($check != 1) {
      		if ((!($_POST['imgAutoLarge'] == 'Y')) && ($_FILES['large_image']['name'] != '')) {
      			// if a specific image is uploaded for large size, resize this instead
      			// of default image.

		      	$large_name = $_FILES['large_image']['tmp_name'];
		      	$large_extension = substr( $_FILES['large_image']['name'],	strrpos($_FILES['large_image']['name'], '.'));
				list($large_width, $large_height) = zen_calculate_image_size($large_name, $largeImageWidth, $largeImageHeight);
				$large_size = $large_width . 'x' . $large_height;
		      	
				// generate directory for original image (not needed anymore after generation)
				mkdirr(DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir']);
			
				// move original image away
				$destination_name = DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir'] . $data['imgBase'] . $data['imgSuffix'] . IMAGE_SUFFIX_LARGE .  $large_extension;
				bmz_set_visible($destination_name);
				if (is_file($destination_name)) {
					@unlink($destination_name);
				}
	      		if ( !rename($large_name, $destination_name) ) {
	      			$messageStack->add( TEXT_MSG_NOCOPY_LARGE, "error" );
	      			$check = 1;
	      		} else {
					$large_name = $destination_name;
	      		}
	      		$source_name = $large_name;
      		} else {
      			$source_name = $default_source_name;
      		}
      		
			if (IMAGE_MANAGER_HANDLER == 'ImageMagick') {
   	  			zen_imagemagick_resize_image($source_name, $image_large, LARGE_IMAGE_BACKGROUND, $large_size, intval(LARGE_IMAGE_QUALITY));
			} elseif (IMAGE_MANAGER_HANDLER == 'GD') {
				zen_gd_resize_image($source_name, $image_large, LARGE_IMAGE_BACKGROUND, $large_width, $large_height, intval(LARGE_IMAGE_QUALITY));
  			}
      		
      	}     
      	
      	// process medium file
      	if ($check != 1) {
      		if ((!($_POST['imgAutoMedium'] == 'Y')) && ($_FILES['medium_image']['name'] != '')) {
      			// if a specific image is uploaded for medium size, resize this instead
      			// of default image.
		      	$medium_name = $_FILES['medium_image']['tmp_name'];
		      	$medium_extension = substr( $_FILES['medium_image']['name'],	strrpos($_FILES['medium_image']['name'], '.'));
				list($medium_width, $medium_height) = zen_calculate_image_size($medium_name, MEDIUM_IMAGE_WIDTH, MEDIUM_IMAGE_HEIGHT);
				$medium_size  = $medium_width . "x" . $medium_height;

				// generate directory for original image (not needed anymore after generation)
				mkdirr(DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir']);
			
				// move original image away
				$destination_name = DIR_FS_CATALOG_IMAGES . "original/" . $data['imgBaseDir'] . $data['imgBase'] . $data['imgSuffix'] . IMAGE_SUFFIX_MEDIUM .  $medium_extension;
				bmz_set_visible($destination_name);
				if (is_file($destination_name)) {
					@unlink($destination_name);
				}
	      		if ( !rename($medium_name, $destination_name) ) {
	      			$messageStack->add( TEXT_MSG_NOCOPY_MEDIUM, "error" );
	      			$check = 1;
	      		} else {
					$medium_name = $destination_name;
	      		}
	      		$source_name = $medium_name;
      		} else {
      			$source_name = $default_source_name;
      		}
			if (IMAGE_MANAGER_HANDLER == 'ImageMagick') {
	  			zen_imagemagick_resize_image($source_name, $image_medium, MEDIUM_IMAGE_BACKGROUND, $medium_size, intval(MEDIUM_IMAGE_QUALITY));
			} elseif (IMAGE_MANAGER_HANDLER == 'GD') {
				zen_gd_resize_image($source_name, $image_medium, LARGE_IMAGE_BACKGROUND, $medium_width, $medium_height, intval(MEDIUM_IMAGE_QUALITY));
  			}
      	}
      	
      	// process smalles default file
      	if ($check != 1) {
			$source_name = $default_source_name;
			if (IMAGE_MANAGER_HANDLER == 'ImageMagick') {
				zen_imagemagick_resize_image($source_name, $image_small, SMALL_IMAGE_BACKGROUND, $small_size, intval(SMALL_IMAGE_QUALITY));
			} elseif (IMAGE_MANAGER_HANDLER == 'GD') {
				zen_gd_resize_image($source_name, $image_small, SMALL_IMAGE_BACKGROUND, $small_width, $small_height, intval(SMALL_IMAGE_QUALITY));
  			}
      	}
      
      
      	if ($check == 1) {
      		if ($_GET['imgEdit'] == 1) {
	      		$action = "layout_edit";
	      	} else {
	      		$action = "layout_new";
	      	}
	      	$repeat_check = 1;
      	} else {
      		// Data has been saved
      		// show the new image information
      		
      		$messageStack->add( TEXT_MSG_IMAGE_SAVED, 'success' );
      		$_GET['imgName'] = $data['imgBase'] . $data['imgSuffix'];
      		$action = "layout_info";
      	}

      	} // of Image-Handler test

		break;
      case 'delete':
      	
      	$data['imgBaseDir'] = $_GET['imgBaseDir'];
      	$data['imgBase'] = $_GET['imgBase'];
      	$data['imgExtension'] = $_GET['imgExtension'];
      	$data['imgSuffix'] = $_GET['imgSuffix'];
      
  		$image_extension = $data['imgExtension'];
		$small_file_extension = $image_extension;
		$medium_file_extension = ((MEDIUM_IMAGE_FILETYPE == 'no_change') ? $image_extension : '.' . MEDIUM_IMAGE_FILETYPE);
		$large_file_extension = ((LARGE_IMAGE_FILETYPE == 'no_change') ? $image_extension : '.' . LARGE_IMAGE_FILETYPE);

  		// add slash to base dir
  		if (($data['imgBaseDir'] != '') && (!ereg("\/$", $data['imgBaseDir']))) {
  			$data['imgBaseDir'] .= '/';	
  		}


      	// Determine file names
      	$data['defaultFileName'] = DIR_FS_CATALOG.DIR_WS_IMAGES
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . $small_file_extension;
      	$data['largeFileName'] = DIR_FS_CATALOG.DIR_WS_IMAGES
      			. 'large/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_LARGE
      			. $large_file_extension;
      	$data['mediumFileName'] = DIR_FS_CATALOG.DIR_WS_IMAGES
      			. 'medium/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_MEDIUM
      			. $medium_file_extension;
      	
      	// check for each file, and delete it!
		bmz_set_visible($data['largeFileName']);
      	if (is_file($data['largeFileName'])) {
      		if (unlink($data['largeFileName'])) {
      			$messageStack->add(TEXT_MSG_LARGE_DELETED, "success");
      		} else {
      			$messageStack->add(TEXT_MSG_NO_DELETE_LARGE, "error");
      		}
      	}
		bmz_set_visible($data['mediumFileName']);
      	if (is_file($data['mediumFileName'])) {
      		if (unlink($data['mediumFileName'])) {
      			$messageStack->add(TEXT_MSG_MEDIUM_DELETED, "success");
      		} else {
      			$messageStack->add(TEXT_MSG_NO_DELETE_MEDIUM, "error");
      		}
      	}
		bmz_set_visible($data['defaultFileName']);
      	if (is_file($data['defaultFileName'])) {
      		if (unlink($data['defaultFileName'])) {
      			$messageStack->add(TEXT_MSG_DEFAULT_DELETED, "success");
      		} else {
      			$messageStack->add(TEXT_MSG_NO_DELETE_DEFAULT, "error");
      		}
      	} else {
      		$messageStack->add(TEXT_MSG_NO_DEFAULT_FILE_FOUND.': '.$data['defaultFileName'], "error");
      	}

		// now delete possibly generated watermarked images:
		
		$watermarked_default = DIR_FS_CATALOG . DIR_WS_IMAGES . 'watermark/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . $small_file_extension;
		$watermarked_medium = DIR_FS_CATALOG . DIR_WS_IMAGES . 'medium/watermark/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_MEDIUM . $medium_file_extension;
		$watermarked_large = DIR_FS_CATALOG . DIR_WS_IMAGES .	 'large/watermark/'
      			. $data['imgBaseDir'] . $data['imgBase'] 
      			. $data['imgSuffix'] . IMAGE_SUFFIX_LARGE . $large_file_extension;

		bmz_set_visible($watermarked_default);
		bmz_set_visible($watermarked_medium);
		bmz_set_visible($watermarked_large);
		if (is_file($watermarked_default)) @unlink($watermarked_default);
		if (is_file($watermarked_medium)) @unlink($watermarked_medium);
		if (is_file($watermarked_large)) @unlink($watermarked_large);
		
      	$action = "";
      
      	break;
      case 'cancel':
      	// set edit message
      	$messageStack->add_session(PRODUCT_WARNING_UPDATE_CANCEL, 'warning');
      	zen_redirect(zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $_GET['products_filter'] . '&current_category_id=' . $current_category_id));
      break;
    }
  }

// ********************************************************************************************

?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
<script language="javascript" src="includes/menu.js"></script>
<script language="javascript" src="includes/general.js"></script>
<link rel="stylesheet" type="text/css" href="includes/javascript/spiffyCal/spiffyCal_v2_1.css">
<script language="JavaScript" src="includes/javascript/spiffyCal/spiffyCal_v2_1.js"></script>

<script type="text/javascript">
  <!--
  function init()
  {
    cssjsmenu('navbar');
    if (document.getElementById)
    {
      var kill = document.getElementById('hoverJS');
      kill.disabled = true;
    }
  }

   function popupWindow(url) {
  		window.open(url,'popupWindow','toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=yes,copyhistory=no,width=600,height=460,screenX=150,screenY=150,top=150,left=150')
	}

  // -->
</script>
</head>
<body onload="init()">
<div id="spiffycalendar" class="text"></div>
<!-- header //-->
<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
<!-- header_eof //-->

<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
<!-- body_text //-->
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
              <tr>
              	<td><table border="0" width="100%" cellspacing="0" cellpadding="2"><tr>
              			<td class="main" align="left">
<?php
$version = zen_get_imagehandler_version();
if ((IMAGE_MANAGER_HANDLER == 'GD') || (IMAGE_MANAGER_HANDLER == 'ImageMagick')) {
	$version = zen_get_imagehandler_version();
	echo '<span class="alert">' . sprintf(USING_IMAGE_HANDLER, $version) . '</span>';
} else {
	echo '<span class="alert">' . NOT_USING_IMAGE_HANDLER . '</span>';
}
?>
              			</td>
                		<td class="smallText" align="right">
               
<?php
// SEARCH DIALOG BOX 

    echo zen_draw_form('search', FILENAME_CATEGORIES, '', 'get');
// show reset search
    if (isset($_GET['search']) && zen_not_null($_GET['search'])) {
      echo '<a href="' . zen_href_link(FILENAME_CATEGORIES) . '">' . zen_image_button('button_reset.gif', IMAGE_RESET) . '</a>&nbsp;&nbsp;';
    }
    echo HEADING_TITLE_SEARCH_DETAIL . ' ' . zen_draw_input_field('search');
    if (isset($_GET['search']) && zen_not_null($_GET['search'])) {
      $keywords = zen_db_input(zen_db_prepare_input($_GET['search']));
      echo '<br/ >' . TEXT_INFO_SEARCH_DETAIL_FILTER . $keywords;
    }
    echo '</form>';    
?>
                </td>
              </tr></table></td></tr>
<tr><td class="main">
<?php
	if (IMAGE_MANAGER_HANDLER && 
		(
			((IMAGE_MANAGER_HANDLER == 'ImageMagick')
					&& (((file_exists(DIR_FS_IMAGE_MAGICK . 'convert')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'composite')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'montage'))))
						|| ((file_exists(DIR_FS_IMAGE_MAGICK . 'convert.exe')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'composite.exe')) && (file_exists(DIR_FS_IMAGE_MAGICK . 'montage.exe'))))
			|| (IMAGE_MANAGER_HANDLER == 'GD'))
		) { // test if some ImageHandler specified
		    echo zen_draw_form('image_query', FILENAME_PRODUCTS_IMAGE_MANAGER, 'action=query_single_images', 'get');
		    define ('QUERY_SIZE_DEFAULT', '20');
		    define ('QUERY_SINGLE_IMAGES_MAXIMUM', 'Search for images exceeding the configured small dimensions (max display): ');
		    $query_size = (isset($_GET['query_size']) && zen_not_null($_GET['query_size'])) ? intval($_GET['query_size']) : QUERY_SIZE_DEFAULT;
		    echo QUERY_SINGLE_IMAGES_MAXIMUM . ' ' . zen_draw_input_field('query_size', $query_size, 'size="5"');
		    echo zen_draw_hidden_field('action', 'query_single_images');
			echo zen_image_submit('button_select.gif', IMAGE_SELECT);
			echo '</form>';
		}
?>
</td></tr>
<?php
if ((zen_not_null($action)) && ($action == 'query_single_images')) {
?>
	<tr>
		<td class="main">
			<?php
				$max_index = count($resizeproducts);
				if ($max_index > 0) {
					for ($index = 0; $index < $max_index; $index++) {
						echo $resizeproducts[$index] . ':&nbsp;' . $resizeimages[$index] . '<br />';
					}
				    echo zen_draw_form('image_resize', FILENAME_PRODUCTS_IMAGE_MANAGER, 'action=resize_single_images', 'get');
					define ('BATCH_RESIZE_IMAGES', 'Batch resize images displayed above?');
					define ('WARNING_OVERWRITE_IMAGES', 'Warning: existing images will be overwritten!');
					echo '<br/ >' . BATCH_RESIZE_IMAGES . '<br />';
				    echo zen_draw_hidden_field('action', 'resize_single_images');
					$images = implode(',', $resizeproducts);
				    echo zen_draw_hidden_field('products', $images);
				    echo '<span class="alert">' . WARNING_OVERWRITE_IMAGES . '</span>';
					echo zen_image_submit('button_update.gif', IMAGE_UPDATE);
					echo '</form>';
				} else {
					define ('MESSAGE_NO_IMAGES_FOUND', 'Nothing to do, no images found.');
				    echo '<span class="alert">' . MESSAGE_NO_IMAGES_FOUND . '</span>';
				}
			    echo '<br />' . zen_draw_form('back_form', FILENAME_PRODUCTS_IMAGE_MANAGER, '', 'get');
				echo zen_image_submit('button_back.gif', IMAGE_BACK);
				echo '</form>';
			?>
		</td>
	</tr>
</table>
</td></tr></table>
<?php	
} elseif ((zen_not_null($action)) && ($action == 'resize_single_images')) {
?>
	<tr>
		<td class="main">
			<?php
	    		while (!$images->EOF) {
	    			$products_previous_image = $images->fields['products_image'];
	    			echo 'resizing ' . $images->fields['products_image'] . '&nbsp;';
					$products_image_name = zen_process_uploaded_image($products_previous_image);
					$db->Execute("update " . TABLE_PRODUCTS . " set products_image='" . $products_image_name . "' where products_image='" . $products_previous_image . "'");
					echo 'done.<br />';
	    			$images->MoveNext();
	    		}
			    echo zen_draw_form('back_form', FILENAME_PRODUCTS_IMAGE_MANAGER, '', 'get');
				echo zen_image_submit('button_back.gif', IMAGE_BACK);
				echo '</form>';
			?>
		</td>
	</tr>
</table>
</td></tr></table>
<?php
} else {

///////////////////////////////////////////////////////////
// 
?>
<?php
	$curr_page = FILENAME_PRODUCTS_IMAGE_MANAGER;
    require(DIR_WS_MODULES . FILENAME_PREV_NEXT_DISPLAY);
?>

      <tr><form name="set_products_filter_id" <?php echo 'action="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'action=set_products_filter') . '"'; ?> method="post"><?php echo zen_draw_hidden_field('products_filter', $_GET['products_filter']); ?>
        <td colspan="2"><table border="0" cellspacing="0" cellpadding="2">
          <tr>
            <td class="main" width="200" align="left" valign="top">&nbsp;</td>
            <td colspan="2" class="main"><?php echo TEXT_PRODUCT_TO_VIEW; ?></td>
          </tr>
          <tr>
            <td class="main" width="200" align="center" valign="top">

<?php
// FIX HERE
if ($_GET['products_filter'] != '') {
  $display_priced_by_attributes = zen_get_products_price_is_priced_by_attributes($_GET['products_filter']);
  echo ($display_priced_by_attributes ? '<span class="alert">' . TEXT_PRICED_BY_ATTRIBUTES . '</span>' . '<br />' : '');
  echo zen_get_products_display_price($_GET['products_filter']) . '<br /><br />';
  echo zen_get_products_quantity_min_units_display($_GET['products_filter'], $include_break = true);
  $not_for_cart = $db->Execute("select p.products_id from " . TABLE_PRODUCTS . " p left join " . TABLE_PRODUCT_TYPES . " pt on p.products_type= pt.type_id where pt.allow_add_to_cart = 'N'");
} else {
  echo '';
  $not_for_cart = '';
}
?>
            </td>
            <td class="attributes-even" align="center"><?php echo zen_draw_products_pull_down('products_filter', 'size="5"', $not_for_cart->fields, true, $_GET['products_filter'], true, true); ?></td>
            <td class="main" align="center" valign="top">
              <?php
                echo zen_image_submit('button_display.gif', IMAGE_DISPLAY);
              ?>
            </td>
          </tr>

        <tr>
          <td colspan="3">
            <table>

<?php
// show when product is linked
if (zen_get_product_is_linked($products_filter) == 'true') {
?>
              <tr>
                <td class="main" align="center" valign="bottom">
                  <?php echo zen_image(DIR_WS_IMAGES . 'icon_yellow_on.gif', IMAGE_ICON_LINKED) . '&nbsp;&nbsp;' . TEXT_LEGEND_LINKED . ' ' . zen_get_product_is_linked($products_filter, 'true'); ?>
                </td>
              </tr>
<?php } ?>
              <tr>
                <td class="main" align="center" valign="bottom">
<?php
  if ($_GET['products_filter'] != '') {
    echo '<a href="' . zen_href_link(FILENAME_CATEGORIES, 'action=new_product' . '&cPath=' . $current_category_id . '&pID=' . $products_filter . '&product_type=' . zen_get_products_type($products_filter)) . '">' . zen_image_button('button_edit_product.gif', IMAGE_EDIT_PRODUCT) . '<br />' . TEXT_PRODUCT_EDIT . '</a>';
    echo '</td><td class="main" align="center" valign="bottom">';
  	echo '<a href="' . zen_href_link(FILENAME_ATTRIBUTES_CONTROLLER, 'products_filter=' . $products_filter . '&current_category_id=' . $current_category_id, 'NONSSL') . '">' . zen_image_button('button_edit_attribs.gif', IMAGE_EDIT_ATTRIBUTES) . '<br />' . TEXT_ATTRIBUTE_EDIT . '</a>' . '&nbsp;&nbsp;&nbsp;';
  }
?>
                </td>
              </tr>
            </table>
          </td>
        </tr>

        </table></td>
      </form></tr>
<?php

///////////////////////////////////////////////////////////
?>


<?php
// start of attributes display
if ($products_filter == '') {
?>
      <tr>
        <td colspan="2" class="pageHeading" align="center" valign="middle" height="200"><?php echo HEADING_TITLE_PRODUCT_SELECT; ?></td>
      </tr>
<?php 
} else {
	// Get the details for the product
	$product = $db->Execute("select p.products_id, p.products_model,
                                      p.products_image, 
                                      p.product_is_free, p.product_is_call, p.products_quantity_mixed, p.products_priced_by_attribute, p.products_status,
                                      p.products_discount_type, p.products_discount_type_from, p.products_price_sorter,
                                      pd.products_name,
                                      p.master_categories_id
                               from " . TABLE_PRODUCTS . " p, " .
                                        TABLE_PRODUCTS_DESCRIPTION . " pd
                               where p.products_id = '" . $_GET['products_filter'] . "'
                               and p.products_id = pd.products_id
                               and pd.language_id = '" . (int)$_SESSION['languages_id'] . "'");


    if ($product->RecordCount() > 0) {
        $pInfo = new objectInfo($product->fields);
    }

	// Determine if there are any images and work out the file names
	// (based on code from modules/pages/product_info/main_template_vars_images(& _additional) (copying is evil!))
	if ($pInfo->products_image != '') {
		
		$products_image = $pInfo->products_image;
		$products_image_match_array = array();

		// get file extension and base
		$products_image_extension = substr($products_image, strrpos($products_image, '.'));
		$products_image_base = preg_replace("/".$products_image_extension."$/", '', $products_image);
				
		// if in a subdirectory
		if (strrpos($products_image_base, '/')) {
			$products_image_base = substr($products_image_base, strrpos($products_image_base, '/')+1);
		}
		
		
		// sort out directory
		$products_image_directory =  substr($products_image, 0, strrpos($products_image, '/'));
  		// add slash to base dir
  		if (($products_image_directory != '') && (!ereg("\/$", $products_image_directory))) {
  			$products_image_directory .= '/';	
  		}
		$products_image_directory_full = DIR_FS_CATALOG . DIR_WS_IMAGES . $products_image_directory;
		
		// Check that the image exists! (out of date Database)
		if (file_exists( $products_image_directory_full . $products_image_base . $products_image_extension )) {

			// Add base image to array
			$products_image_match_array[] = $products_image_base;
			// $products_image_base .= "_";
			
			// Check for additional matching images
			find_additional_images($products_image_match_array, $products_image_directory_full, 
				$products_image_extension, $products_image_base );
		}
		
	} // if products_image

?>

<?php
  if ($pInfo->products_id != '') {
?>
      <tr>
        <td><?php echo zen_draw_separator('pixel_black.gif', '100%', '2'); ?></td>
      </tr>
      <tr>
        <td class="pageHeading">
        	<?php echo TEXT_PRODUCT_INFO . ': #' . $pInfo->products_id . '&nbsp;&nbsp;' . $pInfo->products_name; ?>&nbsp;&nbsp;&nbsp;
        	<?php 
        		if ($pInfo->products_model != '') {
		        	echo TEXT_PRODUCTS_MODEL . ': ' . $pInfo->products_model; 
		        }
        	?>
        	&nbsp;&nbsp;&nbsp;
        	<?php 
        		if ($pInfo->products_image != '') {
        			if (preg_match("/^([^\/]+)\//", $pInfo->products_image, $matches)) {
	        			echo TEXT_IMAGE_BASE_DIR .': ';
	        			echo $matches[1];
        			}
        		}
        	?>
        	</td>
      </tr> 
      <tr>
        <td><?php echo zen_draw_separator('pixel_black.gif', '100%', '2'); ?></td>
      </tr>
      <tr><td><table border="0" width="100%" cellspacing="0" cellpadding="2">
      <!-- The photo listing Table -->
      <tr><td valign="top">
      <table border="0" width="100%" cellspacing="0" cellpadding="2">
      <tr class="dataTableHeadingRow">
      	<td class="dataTableHeadingContent"><?php echo TABLE_HEADING_PHOTO_NAME; ?></td>
      	<td class="dataTableHeadingContent"><?php echo TABLE_HEADING_DEFAULT_SIZE; ?></td>
      	<td class="dataTableHeadingContent"><?php echo TABLE_HEADING_MEDIUM_SIZE; ?></td>
      	<td class="dataTableHeadingContent"><?php echo TABLE_HEADING_LARGE_SIZE; ?></td>
      	<td class="dataTableHeadingContent"><?php echo TABLE_HEADING_PHOTO; ?></td>
      	<td class="dataTableHeadingContent" align="right"><?php echo TABLE_HEADING_ACTION; ?>&nbsp;</td>
      </tr>
<?php
	$count = sizeof($products_image_match_array);
	if (! $count) {
		// no images
		$no_images = 1;
?>
      <tr>
        <td colspan="6" class="dataTableContent" align="center"><?php echo TEXT_NO_PRODUCT_IMAGES; ?></td>
      </tr>
<?php 
	}
?>

<?php
	$first = 1;
	for ($i=0; $i < $count; $i++) {
		// there are some pictures, show them!	
		$tmp_image_name = $products_image_match_array[$i];
		$tmp_image_file = zen_get_small_image($products_image_directory . $tmp_image_name . $products_image_extension);
		$tmp_image_file_full = DIR_FS_CATALOG . $tmp_image_file;
	
		$tmp_image_file_medium = zen_get_medium_image($products_image_directory . $tmp_image_name, $products_image_extension);
		$tmp_image_file_medium_full = DIR_FS_CATALOG . $tmp_image_file_medium;
		
		$tmp_image_file_large = zen_get_large_image($products_image_directory . $tmp_image_name, $products_image_extension);
		$tmp_image_file_large_full = DIR_FS_CATALOG . $tmp_image_file_large;

		// Get file details 
		$text_default_size = get_image_details_string( $tmp_image_file_full );
		$text_medium_size = get_image_details_string( $tmp_image_file_medium_full );
		$text_large_size = get_image_details_string( $tmp_image_file_large_full );

		if ($first == 1) {
			$tmp_image_link = zen_catalog_href_link(FILENAME_POPUP_IMAGE, 'pID=' . $pInfo->products_id);
			$first = 0;
		} else {
			$tmp_image_link = zen_catalog_href_link(FILENAME_POPUP_IMAGE_ADDITIONAL, 
				'pID=' . $pInfo->products_id . '&pic='.($i).'&products_image_large_additional='.$tmp_image_file_large);
		}

		
		if ( $_GET['imgName'] == $tmp_image_name ) {
			// an image is selected, highlight it
			echo '<tr id="defaultSelected" class="dataTableRowSelected" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\'' 
				. zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $_GET['products_filter'] 
				. '&imgName=' .$tmp_image_name . '&action=layout_edit') . '\'">' . "\n";
    		// set some details for later usage
			$selected_image_file = DIR_WS_CATALOG . $tmp_image_file_medium;
			$selected_image_file_large = DIR_WS_CATALOG . $tmp_image_file_large;
    		$selected_image_link = $tmp_image_link;
    		$selected_image_name = $tmp_image_name;
    		$selected_image_suffix = preg_replace("/^".$products_image_base."/", '', $tmp_image_name);
		} else {
			echo '<tr class="dataTableRow" onmouseover="rowOverEffect(this)" onmouseout="rowOutEffect(this)" onclick="document.location.href=\''
				 . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $_GET['products_filter'] 
				 . '&imgName=' . $tmp_image_name . '&action=layout_info') . '\'">' . "\n";
		}
?>
		
			<td class="dataTableContent"><?php echo $tmp_image_name; ?></td>
			<td class="dataTableContent"><?php echo $text_default_size; ?></td>
			<td class="dataTableContent"><?php echo $text_medium_size; ?></td>
			<td class="dataTableContent"><?php echo $text_large_size; ?></td>
			<td class="dataTableContent" align="center">
			
				<?php echo zen_image(DIR_WS_CATALOG . $tmp_image_file, addslashes($products_name), IMAGE_SHOPPING_CART_WIDTH, IMAGE_SHOPPING_CART_HEIGHT, "hspace=\"5\" vspace=\"5\"" ); ?>
			</td>
			<td class="dataTableContent" align="right"><?php 
				if ( $_GET['imgName'] == $tmp_image_name ) { 
					echo zen_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); 
				} else { 
					echo '<a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'products_filter=' . $_GET['products_filter'] 
						. '&imgName=' . $tmp_image_name . '&action=layout_info') 
						. '">' . zen_image(DIR_WS_IMAGES . 'icon_info.gif', IMAGE_ICON_INFO) . '</a>';
				} 
			?>&nbsp;</td>
		</tr>
<?php		
		
	} // for each photo loop
?>
	</table><!-- END Photo list table --></td>
	<!-- Start Data Edit Pane -->
<?php
	$heading = array();
  	$contents = array();

	switch ($action) {
		case 'layout_info':
			// edit
			$heading[] = array('text' => '<b>' . TEXT_INFO_IMAGE_INFO . '</b>');
			$contents = array('form' => zen_draw_form('image_define', FILENAME_PRODUCTS_IMAGE_MANAGER, 
				'page=' . $_GET['page'] . '&products_filter=' . $_GET['products_filter'] . '&action=save', 'post', 'enctype="multipart/form-data"'));
      		$contents[] = array('text' => '<b>'.TEXT_INFO_NAME.': </b>' . $selected_image_name .'<br/>');
      		$contents[] = array('text' => '<b>'.TEXT_INFO_FILE_TYPE.': </b>' . $products_image_extension .'<br/>');
      		$contents[] = array('text' => 
      				'<script language="javascript" type="text/javascript"><!--
							document.write(\'<a href="javascript:popupWindow(\\\'' . $selected_image_link . '\\\')">' 
							. zen_image($selected_image_file, addslashes($products_name), MEDIUM_IMAGE_WIDTH, MEDIUM_IMAGE_HEIGHT, 'hspace="5" vspace="5"') 
							. '<br/>' . TEXT_CLICK_TO_ENLARGE . '</a>\');'
							.'//-->'
				.'</script>
				<noscript>'
				.'<a href="' . zen_href_link($selected_image_file_large) . '" target="_blank">' 
						. zen_image($selected_image_file, $products_name, MEDIUM_IMAGE_WIDTH, MEDIUM_IMAGE_HEIGHT, 'hspace="5" vspace="5"') 
						. TEXT_CLICK_TO_ENLARGE . '</a>'
				.'</noscript>' );
			// show new, delete, and edit buttons
			$contents[] = array('align' => 'center', 'text' => '<br>' .
				' <a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'imgName=' 
				. $_GET['imgName'] . '&products_filter=' . $_GET['products_filter'] . '&action=layout_edit') . '">' 
				. zen_image_button('button_edit.gif', IMAGE_EDIT) . '</a> &nbsp; '
				.' <a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 'imgName=' 
				. $_GET['imgName'] . '&products_filter=' . $_GET['products_filter'] . '&action=layout_delete') . '">' 
				. zen_image_button('button_delete.gif', IMAGE_DELETE) . '</a> &nbsp;'
				.' <a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 
				'&products_filter=' . $_GET['products_filter'] . '&action=layout_new') . '">' 
				. zen_image_button('button_new_file.gif', IMAGE_NEW) . '</a>');
      
			break;
		case 'layout_edit':
			// Edit specific details 
			$imgNameStr = '&imgEdit=1' .'&imgBase=' . $products_image_base
					. "&imgSuffix=" . $selected_image_suffix
					. "&imgBaseDir=" . $products_image_directory 
					. "&imgExtension=" . $products_image_extension;
			$heading[] = array('text' => '<b>' . TEXT_INFO_EDIT_PHOTO . '</b>');

		case 'layout_new':	
			
			if ( $action != 'layout_edit' ) {
				$imgNameStr .= ( $no_images == 1 ) ? "&newImg=1" : '&imgBase='.$products_image_base
					. "&imgBaseDir=" . $products_image_directory 
					. "&imgExtension=" . $products_image_extension;
	 			$heading[] = array('text' => '<b>' . TEXT_INFO_NEW_PHOTO . '</b>');
	 		}
			
			
			$contents = array('form' => zen_draw_form('image_define', FILENAME_PRODUCTS_IMAGE_MANAGER, 
			 	'&products_filter=' . $_GET['products_filter'] . $imgNameStr
				.'&action=save', 'post', 'enctype="multipart/form-data"'));


			// check if this is a master image or if no images exist
			if ($no_images == 1) {
				$contents[] = array('text' => '<b>'.TEXT_INFO_IMAGE_BASE_NAME.'</b><br/>' );
				$contents[] = array('text' =>
					zen_draw_checkbox_field('imgAutoBase', 'Y', 
      				( (($repeat_check != 1) || ($_POST['imgAutoBase'] == 'Y')) ? true : false ) )
      				.TEXT_INFO_AUTOMATIC_FROM_DEFAULT
					. '<br/>'.' or ' . zen_draw_input_field('imgBase', '', 30));
      				
				$dir = @dir(DIR_FS_CATALOG_IMAGES);
      			$dir_info[] = array('id' => '', 'text' => TEXT_INFO_MAIN_DIR);
      			while ($file = $dir->read()) {
        			if (is_dir(DIR_FS_CATALOG_IMAGES . $file) 
        					&& strtoupper($file) != 'CVS' 
        					&& $file != "." 
        					&& $file != ".." 
        					&& $file != 'original' 
        					&& $file != 'medium'
        					&& $file != 'large') {
          				$dir_info[] = array('id' => $file . '/', 'text' => $file);
        			}
      			}
      			$contents[] = array('text' => '<br/><b>'.TEXT_INFO_BASE_DIR.'</b><br/>'.TEXT_INFO_NEW_DIR);
      			$contents[] = array('text' => TEXT_INFO_IMAGE_DIR . zen_draw_pull_down_menu('imgBaseDir', $dir_info, ""));
      			$contents[] = array('text' => TEXT_INFO_OR.' ' . zen_draw_input_field('imgNewBaseDir', '', 20) );

			} else if ($action != 'layout_edit') {
      			$contents[] = array('text' => '<b>'.TEXT_INFO_IMAGE_SUFFIX.'</b><br/>'.TEXT_INFO_USE_AUTO_SUFFIX.'<br/>' );
      			$contents[] = array('text' => zen_draw_checkbox_field('imgAutoSuffix', 'Y', 
      				((($repeat_check != 1) || ($_GET['imgAutoSuffix'] == 'Y')) ? true : false) ) 
      				. ' '.TEXT_INFO_AUTOMATIC. ' '. TEXT_INFO_OR .' '
      				. zen_draw_input_field('imgSuffix', $selected_image_suffix, 10) );
      		}

			// Image fields
      		$contents[] = array('text' => '<br /><b>' . TEXT_INFO_DEFAULT_IMAGE . '</b><br>' 
      				. TEXT_INFO_DEFAULT_IMAGE_HELP . '<br/>'
      				. zen_draw_file_field('default_image') . '<br />' . $ptInfo->default_image);
			$contents[] = array('text' => '<br /><b>' . 'Medium image file (optional)' . '</b><br>' . 
					zen_draw_checkbox_field('imgAutoMedium', 'Y', 
      				((($repeat_check != 1) || ($_POST['imgAutoMedium'] == 'Y')) ? true : false)) . ' '.TEXT_INFO_AUTOMATIC.' '.
					zen_draw_file_field('medium_image') . '<br />' . $ptInfo->medium_image);
			$contents[] = array('text' => '<br /><b>' . 'Large image file (optional)' . '</b><br>' .
					zen_draw_checkbox_field('imgAutoLarge', 'Y', 
      				((($repeat_check != 1) || ($_POST['imgAutoLarge'] == 'Y')) ? true : false)) . ' '.TEXT_INFO_AUTOMATIC.' '.
					zen_draw_file_field('large_image') . '<br />' . $ptInfo->large_image);
			$contents[] = array('align' => 'center', 'text' => '<br>' . zen_image_submit('button_save.gif', IMAGE_SAVE) );
			break;
		case 'layout_delete':
		
			$imgStr = "&imgBase=" . $products_image_base
					. "&imgSuffix=" . $selected_image_suffix
					. "&imgBaseDir=" . $products_image_directory 
					. "&imgExtension=" . $products_image_extension;
					
			// show new button			
			$heading[] = array('text' => '<b>' . TEXT_INFO_CONFIRM_DELETE . '</b>');
			
			$contents[] = array('text' => '<br>' . TEXT_INFO_CONFIRM_DELETE_SURE);
			$contents[] = array('align' => 'center', 'text' => '<br>'
				.' <a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 
				'&products_filter=' . $_GET['products_filter'] . '&action=delete' 
				. $imgStr ) . '">' 
				. zen_image_button( 'button_delete.gif', IMAGE_DELETE ) . '</a>');
			break;
		default:
			// show new button			
			$heading[] = array('text' => '<b>' . TEXT_INFO_SELECT_ACTION . '</b>');
			$contents = array('form' => zen_draw_form('image_define', FILENAME_PRODUCT_TYPES, 'page=' . $_GET['page'] . '&ptID=' . $ptInfo->type_id . '&action=new', 'post', 'enctype="multipart/form-data"'));
			$contents[] = array('text' => '<br>' . TEXT_INFO_CLICK_TO_ADD);
			$contents[] = array('align' => 'center', 'text' => '<br>'
				.' <a href="' . zen_href_link(FILENAME_PRODUCTS_IMAGE_MANAGER, 
				'&products_filter=' . $_GET['products_filter'] . '&action=layout_new') . '">' 
				. zen_image_button('button_new_file.gif', IMAGE_NEW) . '</a>');
			break;
	}
	
	if ( (zen_not_null($heading)) && (zen_not_null($contents)) ) {
    echo '            <td width="25%" valign="top">' . "\n";

    $box = new box;
    echo $box->infoBox($heading, $contents);

    echo '            </td>' . "\n";
  }
?>	
	</tr></table></td></tr>
<?php
	
  } // if products_id

} // if products_filter

} // if !((action == query_single_images) || (action == 'resize_single_images')) 

function get_image_details_string( $filename ) {

	if (!file_exists( $filename )) {
		return "NO";
	}
	$str = "";
	// find out some details about the file 
	$image_size = @getimagesize($filename);
	$image_fs_size = filesize($filename);

	$str .= $image_size[0]."x".$image_size[1];
	$str .= "<br><b>". round($image_fs_size/1024, 2) . "Kb</b>";
	
	return $str;
}

//
// Search the base directory and find additional images
//
function find_additional_images(&$array, $directory, $extension, $base ) {

	$image = $base . $extension;

	// Check for additional matching images
	if ($dir = @dir($directory)) {
		while ($file = $dir->read()) {
			if (!is_dir($directory . $file)) {
				if (substr($file, strrpos($file, '.')) == $extension) {
					if(preg_match("/^" . $base . "/i", $file) == '1') {
						// echo "BASE: ".$base.' FILE: '.$file.'<br>';
						if ($file != $image) {
							if ($base . preg_replace("/^$base/", '', $file) == $file) {
								// remove extension
								$file = preg_replace("/".$extension."$/", '', $file);
								$array[] = $file;
								// echo 'I AM A MATCH ' . $products_image_directory . '/'.$file . $products_image_extension .'<br>';
								
							} else {
								// echo 'I AM NOT A MATCH ' . $file . '<br>';
								
							}	
						}
					}
				}
			}
		}
		
		if (sizeof($array) > 1) {
			sort($array);
		}
		
		$dir->close();
		
		return 1;
	}
	
	return 0;
}
?>


      </tr>
    </table></td>
<!-- body_text_eof //-->
  </tr>
</table>
<!-- body_eof //-->

<!-- footer //-->
<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
<!-- footer_eof //-->
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
